<template>
  <v-app>
    <MenuBar element-id="menuBar"
             @menu-file-open="showOpenDialog = true"
             @menu-file-new="showCreateDialog = true"
             @menu-grid-add-particle="showAddParticleDialog = true"
             @menu-grid-add-circle="showAddCircleDialog = true"
             @menu-sim-edit="showEditSimDialog = true"
    />
    <v-layout row wrap>
    <v-row
        no-gutters
        class="fill-height"
    >
      <v-col cols="12"
             md="2" style="overflow-y: scroll;overflow-x:hidden;" class="scroll">
        <ElementList element-id="elementList" width="100%" height="50%"/>
      </v-col>
      <v-col cols="12" md="8" id="canvasCol">
        <Canvas element-id="canvasElement" width="100%" height="50%" :parent-id="canvasParent"/>
      </v-col>
      <v-col cols="12"
             md="2">
        <InfoDisplay/>
      </v-col>
    </v-row>
    </v-layout>
    <WelcomeDialog :show="showWelcomeDialog" @create="showCreateDialog = true" @open="showOpenDialog = true"/>
    <CreateProjectDialog :show="showCreateDialog" @canceled="showCreateDialog = false" @project="onCreateProject"/>
    <OpenProjectDialog :show="showOpenDialog" @canceled="showOpenDialog = false" @project="onOpenProject"/>
    <AddParticleDialog :show="showAddParticleDialog" @canceled="showAddParticleDialog = false" @saved="showAddParticleDialog = false"></AddParticleDialog>
    <AddCircleDialog :show="showAddCircleDialog" @canceled="showAddCircleDialog = false" @saved="showAddCircleDialog = false"></AddCircleDialog>
    <AppWindow :show="showErr" unsubmitable :cancelable="errCancelable" :title="errTitle" @canceled="showErr = false">
      <br>
      {{ errText }}
    </AppWindow>
  </v-app>
</template>

<script>
import {MenuBar, ElementList, Canvas} from '@/components'
import {
    OpenProject,
    CreateProject,
    Welcome,
    AppWindow,
    AddParticle,
    AddCircle
} from '@/dialogs'
import {Project} from '@/structs'
import {AppContext, Errors} from '@/utils'
import InfoDisplay from '@Compo/InfoDisplay/InfoDisplay'

export default {
  name: 'App',
  components: {
    AppWindow,
    InfoDisplay,
    MenuBar,
    ElementList,
    Canvas,
    OpenProjectDialog: OpenProject,
    CreateProjectDialog: CreateProject,
    WelcomeDialog: Welcome,
    AddParticleDialog: AddParticle,
    AddCircleDialog: AddCircle,
  },
  data: () => ({
    canvasParent: 'canvasCol',
    showWelcomeDialog: true,
    showCreateDialog: false,
    showOpenDialog: false,
    showAddParticleDialog: false,
    showEditSimDialog: false,
    showAddCircleDialog: false,
    showErr: false,
    errTitle: '',
    errText: '',
    errCancelable: true,
  }),
  methods: {
    onOpenProject(name) {
      let p = new Project()

      p.Load(name)
          .then(() => {
            this.showOpenDialog = false
            this.showWelcomeDialog = false
            this.unlockApp(p)
          })
          .catch(e => AppContext.showError(e))
    },
    onCreateProject(name) {
      let p = new Project()
      p.name = name
      p.Save()
          .then(() => {
            this.showCreateDialog = false
            this.showWelcomeDialog = false
            this.unlockApp(p)
          })
      .catch(e => AppContext.showError(e))
    },
    onAppContextShowError(e) {
      let err = Errors[e.code]
      this.errTitle = err.title
      this.errText = err.text
      this.errCancelable = err.cancelable
      this.showErr = true
    },
    unlockApp(p) {
      AppContext.currentProject = p
      AppContext.mode = 2
    }
  },
  created() {
    AppContext.errCallback = this.onAppContextShowError
  }
}
</script>

<style>
.noSelect {
  -webkit-touch-callout: none; /* iOS Safari */
  -webkit-user-select: none; /* Safari */
  -moz-user-select: none; /* Old versions of Firefox */
  -ms-user-select: none; /* Internet Explorer/Edge */
  user-select: none; /* Non-prefixed version, currently */
}
#elementList {
  background-color: blue;

}

.scroll::-webkit-scrollbar-track {
  background-color: #292929;
  width: 7px;
}

.scroll::-webkit-scrollbar {
  width: 8px;
  background-color: #F5F5F5;
}

.scroll::-webkit-scrollbar-thumb {
  border-radius: 10px;
  -webkit-box-shadow: inset 0 0 6px rgba(0,0,0,.3);
  background-color: #6d5394;
}
</style>
